Package org.mariadb.jdbc

## Class Statement

- java.lang.Object
- - org.mariadb.jdbc.Statement

All Implemented Interfaces:
  `AutoCloseable`, `Statement`, `Wrapper`

Direct Known Subclasses:
  `BasePreparedStatement`

    public class Statement
    extends Object
    implements Statement

### Field Summary

Fields
`protected int` `autoGeneratedKeys`
`protected boolean` `canUseServerMaxRows`
`protected boolean` `canUseServerTimeout`
`protected boolean` `closed`
`protected boolean` `closeOnCompletion`
`protected Connection` `con`
`protected Completion` `currResult`
`protected boolean` `escape`
`protected int` `fetchSize`
`protected ReentrantLock` `lock`
`protected long` `maxRows`
`protected int` `queryTimeout`
`protected List<Completion>` `results`
`protected int` `resultSetConcurrency`
`protected int` `resultSetType`

### Fields inherited from interface java.sql.Statement

`CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

### Constructor Summary

Constructors
`Statement​(Connection con, ReentrantLock lock, boolean canUseServerTimeout, boolean canUseServerMaxRows, int autoGeneratedKeys, int resultSetType, int resultSetConcurrency, int defaultFetchSize)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `abort()`
`void` `addBatch​(String sql)` Adds the given SQL command to the current list of commands for this `Statement` object.
`void` `cancel()` Cancels this `Statement` object if both the DBMS and driver support aborting an SQL statement.
`protected void` `checkNotClosed()` Check if statement is closed, and throw exception if so.
`void` `clearBatch()` Empties this `Statement` object's current list of SQL commands.
`void` `clearWarnings()` Clears all the warnings reported on this `Statement` object.
`void` `close()` Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed.
`void` `closeOnCompletion()` Specifies that this `Statement` will be closed when all its dependent result sets are closed.
`protected String` `escapeTimeout​(String sql)`
`protected ExceptionFactory` `exceptionFactory()`
`boolean` `execute​(String sql)` Executes the given SQL statement, which may return multiple results.
`boolean` `execute​(String sql, int autoGeneratedKeys)` Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval.
`boolean` `execute​(String sql, int[] columnIndexes)` Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`boolean` `execute​(String sql, String[] columnNames)` Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`int[]` `executeBatch()` Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts.
`List<Completion>` `executeInternalBatchPipeline()`
`List<Completion>` `executeInternalBatchStandard()`
`long[]` `executeLargeBatch()` Execute batch, like executeBatch(), with returning results with long[].
`long` `executeLargeUpdate​(String sql)` Executes the given SQL statement, which may be an INSERT, UPDATE, or DELETE statement or an SQL statement that returns nothing, such as an SQL DDL statement.
`long` `executeLargeUpdate​(String sql, int autoGeneratedKeys)` Identical to executeLargeUpdate(String sql), with a flag that indicate that autoGeneratedKeys (primary key fields with "auto_increment") generated id's must be retrieved.
`long` `executeLargeUpdate​(String sql, int[] columnIndexes)` Identical to executeLargeUpdate(String sql, int autoGeneratedKeys) with autoGeneratedKeys = Statement.RETURN_GENERATED_KEYS set.
`long` `executeLargeUpdate​(String sql, String[] columnNames)` Identical to executeLargeUpdate(String sql, int autoGeneratedKeys) with autoGeneratedKeys = Statement.RETURN_GENERATED_KEYS set.
`ResultSet` `executeQuery​(String sql)` Executes the given SQL statement, which returns a single `ResultSet` object.
`int` `executeUpdate​(String sql)` Executes the given SQL statement, which may be an `INSERT`, `UPDATE`, or `DELETE` statement or an SQL statement that returns nothing, such as an SQL DDL statement.
`int` `executeUpdate​(String sql, int autoGeneratedKeys)` Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval.
`int` `executeUpdate​(String sql, int[] columnIndexes)` Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`int` `executeUpdate​(String sql, String[] columnNames)` Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`void` `fetchRemaining()` Permit to streaming result to fetch remaining results.
`Connection` `getConnection()` Retrieves the `Connection` object that produced this `Statement` object.
`int` `getFetchDirection()` Retrieves the direction for fetching rows from database tables that is the default for result sets generated from this `Statement` object.
`int` `getFetchSize()` Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object.
`ResultSet` `getGeneratedKeys()` Retrieves any auto-generated keys created as a result of executing this `Statement` object.
`long` `getLargeMaxRows()` Retrieves the maximum number of rows that a ResultSet object produced by this Statement object can contain.
`long` `getLargeUpdateCount()` Retrieves the current result as an update count; if the result is a ResultSet object or there are no more results, -1 is returned.
`int` `getMaxFieldSize()` Retrieves the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object.
`int` `getMaxRows()` Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain.
`boolean` `getMoreResults()` Moves to this `Statement` object's next result, returns `true` if it is a `ResultSet` object, and implicitly closes any current `ResultSet` object(s) obtained with the method `getResultSet`.
`boolean` `getMoreResults​(int current)` Moves to this `Statement` object's next result, deals with any current `ResultSet` object(s) according to the instructions specified by the given flag, and returns `true` if the next result is a `ResultSet` object.
`int` `getQueryTimeout()` Retrieves the number of seconds the driver will wait for a `Statement` object to execute.
`ResultSet` `getResultSet()` Retrieves the current result as a `ResultSet` object.
`int` `getResultSetConcurrency()` Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.
`int` `getResultSetHoldability()` Retrieves the result set holdability for `ResultSet` objects generated by this `Statement` object.
`int` `getResultSetType()` Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.
`int` `getUpdateCount()` Retrieves the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned.
`SQLWarning` `getWarnings()` Retrieves the first warning reported by calls on this `Statement` object.
`boolean` `isClosed()` Retrieves whether this `Statement` object has been closed.
`boolean` `isCloseOnCompletion()` Returns a value indicating whether this `Statement` will be closed when all its dependent result sets are closed.
`boolean` `isPoolable()` Returns a value indicating whether the `Statement` is poolable or not.
`boolean` `isWrapperFor​(Class<?> iface)` Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does.
`void` `setCursorName​(String name)` Sets the SQL cursor name to the given `String`, which will be used by subsequent `Statement` object `execute` methods.
`void` `setEscapeProcessing​(boolean enable)` Sets escape processing on or off.
`void` `setFetchDirection​(int direction)` Gives the driver a hint as to the direction in which rows will be processed in `ResultSet` objects created using this `Statement` object.
`void` `setFetchSize​(int rows)` Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for `ResultSet` objects generated by this `Statement` .
`void` `setLargeMaxRows​(long max)` Sets the limit for the maximum number of rows that any ResultSet object generated by this Statement object can contain to the given number.
`void` `setMaxFieldSize​(int max)` NOT SUPPORTED.
`void` `setMaxRows​(int max)` Sets the limit for the maximum number of rows that any `ResultSet` object generated by this `Statement` object can contain to the given number.
`void` `setPoolable​(boolean poolable)` Requests that a `Statement` be pooled or not pooled.
`void` `setQueryTimeout​(int seconds)` Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds.
`<T> T` `unwrap​(Class<T> iface)` Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface java.sql.Statement

`enquoteIdentifier, enquoteLiteral, enquoteNCharLiteral, isSimpleIdentifier`

### Field Detail

#### resultSetType

    protected final int resultSetType

#### resultSetConcurrency

    protected final int resultSetConcurrency

#### lock

    protected final ReentrantLock lock

#### canUseServerTimeout

    protected final boolean canUseServerTimeout

#### canUseServerMaxRows

    protected final boolean canUseServerMaxRows

#### con

    protected final Connection con

#### queryTimeout

    protected int queryTimeout

#### maxRows

    protected long maxRows

#### fetchSize

    protected int fetchSize

#### autoGeneratedKeys

    protected int autoGeneratedKeys

#### closeOnCompletion

    protected boolean closeOnCompletion

#### closed

    protected boolean closed

#### escape

    protected boolean escape

#### results

    protected List<Completion> results

#### currResult

    protected Completion currResult

### Constructor Detail

#### Statement

    public Statement​(Connection con,
                     ReentrantLock lock,
                     boolean canUseServerTimeout,
                     boolean canUseServerMaxRows,
                     int autoGeneratedKeys,
                     int resultSetType,
                     int resultSetConcurrency,
                     int defaultFetchSize)

### Method Detail

#### exceptionFactory

    protected ExceptionFactory exceptionFactory()

#### executeQuery

    public ResultSet executeQuery​(String sql)
                           throws SQLException

Executes the given SQL statement, which returns a single `ResultSet` object.

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `executeQuery` in interface `Statement`
Parameters:
  `sql` - an SQL statement to be sent to the database, typically a static SQL `SELECT` statement
Returns:
  a `ResultSet` object that contains the data produced by the given query; never `null`
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the given SQL statement produces anything other than a single `ResultSet` object, the method is called on a `PreparedStatement` or `CallableStatement`
  `SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`

#### executeUpdate

    public int executeUpdate​(String sql)
                      throws SQLException

Executes the given SQL statement, which may be an `INSERT`, `UPDATE`, or `DELETE` statement or an SQL statement that returns nothing, such as an SQL DDL statement.

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `executeUpdate` in interface `Statement`
Parameters:
  `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
Returns:
  either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the given SQL statement produces a `ResultSet` object, the method is called on a `PreparedStatement` or `CallableStatement`
  `SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`

#### close

    public void close()
               throws SQLException

Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed. It is generally good practice to release resources as soon as you are finished with them to avoid tying up database resources.

Calling the method `close` on a `Statement` object that is already closed has no effect.

Note:When a `Statement` object is closed, its current `ResultSet` object, if one exists, is also closed.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Statement`
Throws:
  `SQLException` - if a database access error occurs

#### abort

    public void abort()

#### getMaxFieldSize

    public int getMaxFieldSize()

Retrieves the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object. This limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, `NCHAR`, `NVARCHAR`, `LONGNVARCHAR` and `LONGVARCHAR` columns. If the limit is exceeded, the excess data is silently discarded.

Specified by:
  `getMaxFieldSize` in interface `Statement`
Returns:
  the current column size limit for columns storing character and binary values; zero means there is no limit
See Also:
  `setMaxFieldSize(int)`

#### setMaxFieldSize

    public void setMaxFieldSize​(int max)

NOT SUPPORTED.

Specified by:
  `setMaxFieldSize` in interface `Statement`
See Also:
  `getMaxFieldSize()`

#### getMaxRows

    public int getMaxRows()
                   throws SQLException

Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain. If this limit is exceeded, the excess rows are silently dropped.

Specified by:
  `getMaxRows` in interface `Statement`
Returns:
  the current maximum number of rows for a `ResultSet` object produced by this `Statement` object; zero means there is no limit
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
See Also:
  `setMaxRows(int)`

#### setMaxRows

    public void setMaxRows​(int max)
                    throws SQLException

Sets the limit for the maximum number of rows that any `ResultSet` object generated by this `Statement` object can contain to the given number. If the limit is exceeded, the excess rows are silently dropped.

Specified by:
  `setMaxRows` in interface `Statement`
Parameters:
  `max` - the new max rows limit; zero means there is no limit
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `max >= 0` is not satisfied
See Also:
  `getMaxRows()`

#### setEscapeProcessing

    public void setEscapeProcessing​(boolean enable)
                             throws SQLException

Sets escape processing on or off. If escape scanning is on (the default), the driver will do escape substitution before sending the SQL statement to the database.

The `Connection` and `DataSource` property `escapeProcessing` may be used to change the default escape processing behavior. A value of true (the default) enables escape Processing for all `Statement` objects. A value of false disables escape processing for all `Statement` objects. The `setEscapeProcessing` method may be used to specify the escape processing behavior for an individual `Statement` object.

Note: Since prepared statements have usually been parsed prior to making this call, disabling escape processing for `PreparedStatements` objects will have no effect.

Specified by:
  `setEscapeProcessing` in interface `Statement`
Parameters:
  `enable` - `true` to enable escape processing; `false` to disable it
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`

#### getQueryTimeout

    public int getQueryTimeout()
                        throws SQLException

Retrieves the number of seconds the driver will wait for a `Statement` object to execute. If the limit is exceeded, a `SQLException` is thrown.

Specified by:
  `getQueryTimeout` in interface `Statement`
Returns:
  the current query timeout limit in seconds; zero means there is no limit
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
See Also:
  `setQueryTimeout(int)`

#### setQueryTimeout

    public void setQueryTimeout​(int seconds)
                         throws SQLException

Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds. By default, there is no limit on the amount of time allowed for a running statement to complete. If the limit is exceeded, an `SQLTimeoutException` is thrown. A JDBC driver must apply this limit to the `execute`, `executeQuery` and `executeUpdate` methods.

Note: JDBC driver implementations may also apply this limit to `ResultSet` methods (consult your driver vendor documentation for details).

Note: In the case of `Statement` batching, it is implementation defined whether the time-out is applied to individual SQL commands added via the `addBatch` method or to the entire batch of SQL commands invoked by the `executeBatch` method (consult your driver vendor documentation for details).

Specified by:
  `setQueryTimeout` in interface `Statement`
Parameters:
  `seconds` - the new query timeout limit in seconds; zero means there is no limit
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `seconds >= 0` is not satisfied
See Also:
  `getQueryTimeout()`

#### cancel

    public void cancel()
                throws SQLException

Cancels this `Statement` object if both the DBMS and driver support aborting an SQL statement. This method can be used by one thread to cancel a statement that is being executed by another thread.

Specified by:
  `cancel` in interface `Statement`
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### getWarnings

    public SQLWarning getWarnings()
                           throws SQLException

Retrieves the first warning reported by calls on this `Statement` object. Subsequent `Statement` object warnings will be chained to this `SQLWarning` object.

The warning chain is automatically cleared each time a statement is (re)executed. This method may not be called on a closed `Statement` object; doing so will cause an `SQLException` to be thrown.

Note: If you are processing a `ResultSet` object, any warnings associated with reads on that `ResultSet` object will be chained on it rather than on the `Statement` object that produced it.

Specified by:
  `getWarnings` in interface `Statement`
Returns:
  the first `SQLWarning` object or `null` if there are no warnings
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`

#### clearWarnings

    public void clearWarnings()

Clears all the warnings reported on this `Statement` object. After a call to this method, the method `getWarnings` will return `null` until a new warning is reported for this `Statement` object.

Specified by:
  `clearWarnings` in interface `Statement`

#### setCursorName

    public void setCursorName​(String name)
                       throws SQLException

Sets the SQL cursor name to the given `String`, which will be used by subsequent `Statement` object `execute` methods. This name can then be used in SQL positioned update or delete statements to identify the current row in the `ResultSet` object generated by this statement. If the database does not support positioned update/delete, this method is a noop. To ensure that a cursor has the proper isolation level to support updates, the cursor's `SELECT` statement should have the form `SELECT FOR UPDATE`. If `FOR UPDATE` is not present, positioned updates may fail.

Note: By definition, the execution of positioned updates and deletes must be done by a different `Statement` object than the one that generated the `ResultSet` object being used for positioning. Also, cursor names must be unique within a connection.

Specified by:
  `setCursorName` in interface `Statement`
Parameters:
  `name` - the new cursor name, which must be unique within a connection
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### execute

    public boolean execute​(String sql)
                    throws SQLException

Executes the given SQL statement, which may return multiple results. In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `execute` in interface `Statement`
Parameters:
  `sql` - any SQL statement
Returns:
  `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the method is called on a `PreparedStatement` or `CallableStatement`
  `SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
See Also:
  `getResultSet()`, `getUpdateCount()`, `getMoreResults()`

#### getResultSet

    public ResultSet getResultSet()
                           throws SQLException

Retrieves the current result as a `ResultSet` object. This method should be called only once per result.

Specified by:
  `getResultSet` in interface `Statement`
Returns:
  the current result as a `ResultSet` object or `null` if the result is an update count or there are no more results
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
See Also:
  `execute(java.lang.String)`

#### getUpdateCount

    public int getUpdateCount()
                       throws SQLException

Retrieves the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned. This method should be called only once per result.

Specified by:
  `getUpdateCount` in interface `Statement`
Returns:
  the current result as an update count; -1 if the current result is a `ResultSet` object or there are no more results
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
See Also:
  `execute(java.lang.String)`

#### getMoreResults

    public boolean getMoreResults()
                           throws SQLException

Moves to this `Statement` object's next result, returns `true` if it is a `ResultSet` object, and implicitly closes any current `ResultSet` object(s) obtained with the method `getResultSet`.

There are no more results when the following is true:

     // stmt is a Statement object
     ((stmt.getMoreResults() == false) && (stmt.getUpdateCount() == -1))

Specified by:
  `getMoreResults` in interface `Statement`
Returns:
  `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
See Also:
  `execute(java.lang.String)`

#### getFetchDirection

    public int getFetchDirection()

Retrieves the direction for fetching rows from database tables that is the default for result sets generated from this `Statement` object. If this `Statement` object has not set a fetch direction by calling the method `setFetchDirection`, the return value is implementation-specific.

Specified by:
  `getFetchDirection` in interface `Statement`
Returns:
  the default fetch direction for result sets generated from this `Statement` object
Since:
  1.2
See Also:
  `setFetchDirection(int)`

#### setFetchDirection

    public void setFetchDirection​(int direction)

Gives the driver a hint as to the direction in which rows will be processed in `ResultSet` objects created using this `Statement` object. The default value is `ResultSet.FETCH_FORWARD`.

Note that this method sets the default fetch direction for result sets generated by this `Statement` object. Each result set has its own methods for getting and setting its own fetch direction.

Specified by:
  `setFetchDirection` in interface `Statement`
Parameters:
  `direction` - the initial direction for processing rows

#### getFetchSize

    public int getFetchSize()
                     throws SQLException

Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object. If this `Statement` object has not set a fetch size by calling the method `setFetchSize`, the return value is implementation-specific.

Specified by:
  `getFetchSize` in interface `Statement`
Returns:
  the default fetch size for result sets generated from this `Statement` object
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
See Also:
  `setFetchSize(int)`

#### setFetchSize

    public void setFetchSize​(int rows)
                      throws SQLException

Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for `ResultSet` objects generated by this `Statement` . If the value specified is zero, then the hint is ignored. The default value is zero.

Specified by:
  `setFetchSize` in interface `Statement`
Parameters:
  `rows` - the number of rows to fetch
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `rows >= 0` is not satisfied.
Since:
  1.2
See Also:
  `getFetchSize()`

#### getResultSetConcurrency

    public int getResultSetConcurrency()
                                throws SQLException

Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.

Specified by:
  `getResultSetConcurrency` in interface `Statement`
Returns:
  either `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`

#### getResultSetType

    public int getResultSetType()

Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.

Specified by:
  `getResultSetType` in interface `Statement`
Returns:
  one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
Since:
  1.2

#### addBatch

    public void addBatch​(String sql)
                  throws SQLException

Adds the given SQL command to the current list of commands for this `Statement` object. The commands in this list can be executed as a batch by calling the method `executeBatch`.

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `addBatch` in interface `Statement`
Parameters:
  `sql` - typically this is an SQL `INSERT` or `UPDATE` statement
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the driver does not support batch updates, the method is called on a `PreparedStatement` or `CallableStatement`
See Also:
  `executeBatch()`, `DatabaseMetaData.supportsBatchUpdates()`

#### clearBatch

    public void clearBatch()
                    throws SQLException

Empties this `Statement` object's current list of SQL commands.

Specified by:
  `clearBatch` in interface `Statement`
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch updates
Since:
  1.2
See Also:
  `addBatch(java.lang.String)`, `DatabaseMetaData.supportsBatchUpdates()`

#### executeBatch

    public int[] executeBatch()
                       throws SQLException

Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts. The `int` elements of the array that is returned are ordered to correspond to the commands in the batch, which are ordered according to the order in which they were added to the batch. The elements in the array returned by the method `executeBatch` may be one of the following:

1. A number greater than or equal to zero -- indicates that the command was processed successfully and is an update count giving the number of rows in the database that were affected by the command's execution
2. A value of `SUCCESS_NO_INFO` -- indicates that the command was processed successfully but that the number of rows affected is unknown

   If one of the commands in a batch update fails to execute properly, this method throws a `BatchUpdateException`, and a JDBC driver may or may not continue to process the remaining commands in the batch. However, the driver's behavior must be consistent with a particular DBMS, either always continuing to process commands or never continuing to process commands. If the driver continues processing after a failure, the array returned by the method `BatchUpdateException.getUpdateCounts` will contain as many elements as there are commands in the batch, and at least one of the elements will be the following:

3. A value of `EXECUTE_FAILED` -- indicates that the command failed to execute successfully and occurs only if a driver continues to process commands after a command fails

The possible implementations and return values have been modified in the Java 2 SDK, Standard Edition, version 1.3 to accommodate the option of continuing to process commands in a batch update after a `BatchUpdateException` object has been thrown.

Specified by:
  `executeBatch` in interface `Statement`
Returns:
  an array of update counts containing one element for each command in the batch. The elements of the array are ordered according to the order in which commands were added to the batch.
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch statements. Throws `BatchUpdateException` (a subclass of `SQLException`) if one of the commands sent to the database fails to execute properly or attempts to return a result set.
  `SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
Since:
  1.2
See Also:
  `addBatch(java.lang.String)`, `DatabaseMetaData.supportsBatchUpdates()`

#### getConnection

    public Connection getConnection()
                             throws SQLException

Retrieves the `Connection` object that produced this `Statement` object.

Specified by:
  `getConnection` in interface `Statement`
Returns:
  the connection that produced this statement
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
Since:
  1.2

#### getMoreResults

    public boolean getMoreResults​(int current)
                           throws SQLException

Moves to this `Statement` object's next result, deals with any current `ResultSet` object(s) according to the instructions specified by the given flag, and returns `true` if the next result is a `ResultSet` object.

There are no more results when the following is true:

     // stmt is a Statement object
     ((stmt.getMoreResults(current) == false) && (stmt.getUpdateCount() == -1))

Specified by:
  `getMoreResults` in interface `Statement`
Parameters:
  `current` - one of the following `Statement` constants indicating what should happen to current `ResultSet` objects obtained using the method `getResultSet`: `Statement.CLOSE_CURRENT_RESULT`, `Statement.KEEP_CURRENT_RESULT`, or `Statement.CLOSE_ALL_RESULTS`
Returns:
  `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the argument supplied is not one of the following: `Statement.CLOSE_CURRENT_RESULT`, `Statement.KEEP_CURRENT_RESULT` or `Statement.CLOSE_ALL_RESULTS`
  `SQLFeatureNotSupportedException` - if `DatabaseMetaData.supportsMultipleOpenResults` returns `false` and either `Statement.KEEP_CURRENT_RESULT` or `Statement.CLOSE_ALL_RESULTS` are supplied as the argument.
Since:
  1.4
See Also:
  `execute(java.lang.String)`

#### fetchRemaining

    public void fetchRemaining()
                        throws SQLException

Permit to streaming result to fetch remaining results.

Throws:
  `SQLException` - if socket error occurs.

#### getGeneratedKeys

    public ResultSet getGeneratedKeys()
                               throws SQLException

Retrieves any auto-generated keys created as a result of executing this `Statement` object. If this `Statement` object did not generate any keys, an empty `ResultSet` object is returned.

Note:If the columns which represent the auto-generated keys were not specified, the JDBC driver implementation will determine the columns which best represent the auto-generated keys.

Specified by:
  `getGeneratedKeys` in interface `Statement`
Returns:
  a `ResultSet` object containing the auto-generated key(s) generated by the execution of this `Statement` object
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### executeUpdate

    public int executeUpdate​(String sql,
                             int autoGeneratedKeys)
                      throws SQLException

Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval. The driver will ignore the flag if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `executeUpdate` in interface `Statement`
Parameters:
  `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
  `autoGeneratedKeys` - a flag indicating whether auto-generated keys should be made available for retrieval; one of the following constants: `Statement.RETURN_GENERATED_KEYS` `Statement.NO_GENERATED_KEYS`
Returns:
  either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the given SQL statement returns a `ResultSet` object, the given constant is not one of those allowed, the method is called on a `PreparedStatement` or `CallableStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method with a constant of Statement.RETURN_GENERATED_KEYS
  `SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
Since:
  1.4

#### executeUpdate

    public int executeUpdate​(String sql,
                             int[] columnIndexes)
                      throws SQLException

Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `executeUpdate` in interface `Statement`
Parameters:
  `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
  `columnIndexes` - an array of column indexes indicating the columns that should be returned from the inserted row
Returns:
  either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the SQL statement returns a `ResultSet` object,the second argument supplied to this method is not an `int` array whose elements are valid column indexes, the method is called on a `PreparedStatement` or `CallableStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
  `SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
Since:
  1.4

#### executeUpdate

    public int executeUpdate​(String sql,
                             String[] columnNames)
                      throws SQLException

Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the names of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `executeUpdate` in interface `Statement`
Parameters:
  `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
  `columnNames` - an array of the names of the columns that should be returned from the inserted row
Returns:
  either the row count for `INSERT`, `UPDATE`, or `DELETE` statements, or 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the SQL statement returns a `ResultSet` object, the second argument supplied to this method is not a `String` array whose elements are valid column names, the method is called on a `PreparedStatement` or `CallableStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
  `SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
Since:
  1.4

#### execute

    public boolean execute​(String sql,
                           int autoGeneratedKeys)
                    throws SQLException

Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval. The driver will ignore this signal if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `execute` in interface `Statement`
Parameters:
  `sql` - any SQL statement
  `autoGeneratedKeys` - a constant indicating whether auto-generated keys should be made available for retrieval using the method `getGeneratedKeys`; one of the following constants: `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`
Returns:
  `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the second parameter supplied to this method is not `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`, the method is called on a `PreparedStatement` or `CallableStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method with a constant of Statement.RETURN_GENERATED_KEYS
  `SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
Since:
  1.4
See Also:
  `getResultSet()`, `getUpdateCount()`, `getMoreResults()`, `getGeneratedKeys()`

#### escapeTimeout

    protected String escapeTimeout​(String sql)
                            throws SQLException

Throws:
  `SQLException`

#### execute

    public boolean execute​(String sql,
                           int[] columnIndexes)
                    throws SQLException

Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

Under some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `execute` in interface `Statement`
Parameters:
  `sql` - any SQL statement
  `columnIndexes` - an array of the indexes of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
Returns:
  `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the elements in the `int` array passed to this method are not valid column indexes, the method is called on a `PreparedStatement` or `CallableStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
  `SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
Since:
  1.4
See Also:
  `getResultSet()`, `getUpdateCount()`, `getMoreResults()`

#### execute

    public boolean execute​(String sql,
                           String[] columnNames)
                    throws SQLException

Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the names of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `execute` in interface `Statement`
Parameters:
  `sql` - any SQL statement
  `columnNames` - an array of the names of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
Returns:
  `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`,the elements of the `String` array passed to this method are not valid column names, the method is called on a `PreparedStatement` or `CallableStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
  `SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
Since:
  1.4
See Also:
  `getResultSet()`, `getUpdateCount()`, `getMoreResults()`, `getGeneratedKeys()`

#### getResultSetHoldability

    public int getResultSetHoldability()

Retrieves the result set holdability for `ResultSet` objects generated by this `Statement` object.

Specified by:
  `getResultSetHoldability` in interface `Statement`
Returns:
  either `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
Since:
  1.4

#### isClosed

    public boolean isClosed()

Retrieves whether this `Statement` object has been closed. A `Statement` is closed if the method close has been called on it, or if it is automatically closed.

Specified by:
  `isClosed` in interface `Statement`
Returns:
  true if this `Statement` object is closed; false if it is still open

#### isPoolable

    public boolean isPoolable()
                       throws SQLException

Returns a value indicating whether the `Statement` is poolable or not.

Specified by:
  `isPoolable` in interface `Statement`
Returns:
  `true` if the `Statement` is poolable; `false` otherwise
Throws:
  `SQLException` - if this method is called on a closed `Statement`
See Also:
  `setPoolable(boolean)`

#### setPoolable

    public void setPoolable​(boolean poolable)
                     throws SQLException

Requests that a `Statement` be pooled or not pooled. The value specified is a hint to the statement pool implementation indicating whether the application wants the statement to be pooled. It is up to the statement pool manager whether the hint is used.

The poolable value of a statement is applicable to both internal statement caches implemented by the driver and external statement caches implemented by application servers and other applications.

By default, a `Statement` is not poolable when created, and a `PreparedStatement` and `CallableStatement` are poolable when created.

Specified by:
  `setPoolable` in interface `Statement`
Parameters:
  `poolable` - requests that the statement be pooled if true and that the statement not be pooled if false
Throws:
  `SQLException` - if this method is called on a closed `Statement`

#### closeOnCompletion

    public void closeOnCompletion()
                           throws SQLException

Specifies that this `Statement` will be closed when all its dependent result sets are closed. If execution of the `Statement` does not produce any result sets, this method has no effect.

Note: Multiple calls to `closeOnCompletion` do not toggle the effect on this `Statement`. However, a call to `closeOnCompletion` does affect both the subsequent execution of statements, and statements that currently have open, dependent, result sets.

Specified by:
  `closeOnCompletion` in interface `Statement`
Throws:
  `SQLException` - if this method is called on a closed `Statement`

#### isCloseOnCompletion

    public boolean isCloseOnCompletion()
                                throws SQLException

Returns a value indicating whether this `Statement` will be closed when all its dependent result sets are closed.

Specified by:
  `isCloseOnCompletion` in interface `Statement`
Returns:
  `true` if the `Statement` will be closed when all of its dependent result sets are closed; `false` otherwise
Throws:
  `SQLException` - if this method is called on a closed `Statement`

#### unwrap

    public <T> T unwrap​(Class<T> iface)
                 throws SQLException

Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

If the receiver implements the interface then the result is the receiver or a proxy for the receiver. If the receiver is a wrapper and the wrapped object implements the interface then the result is the wrapped object or a proxy for the wrapped object. Otherwise, return the result of calling `unwrap` recursively on the wrapped object or a proxy for that result. If the receiver is not a wrapper and does not implement the interface, then an `SQLException` is thrown.

Specified by:
  `unwrap` in interface `Wrapper`
Parameters:
  `iface` - A Class defining an interface that the result must implement.
Returns:
  an object that implements the interface. Maybe a proxy for the actual implementing object.
Throws:
  `SQLException` - If no object found that implements the interface

#### isWrapperFor

    public boolean isWrapperFor​(Class<?> iface)

Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does. Returns false otherwise. If this implements the interface then return true, else if this is a wrapper then return the result of recursively calling `isWrapperFor` on the wrapped object. If this does not implement the interface and is not a wrapper, return false. This method should be implemented as a low-cost operation compared to `unwrap` so that callers can use this method to avoid expensive `unwrap` calls that may fail. If this method returns true then calling `unwrap` with the same argument should succeed.

Specified by:
  `isWrapperFor` in interface `Wrapper`
Parameters:
  `iface` - a Class defining an interface.
Returns:
  true if this implements the interface or directly or indirectly wraps an object that does.

#### checkNotClosed

    protected void checkNotClosed()
                           throws SQLException

Check if statement is closed, and throw exception if so.

Throws:
  `SQLException` - if statement close

#### executeLargeUpdate

    public long executeLargeUpdate​(String sql)
                            throws SQLException

Executes the given SQL statement, which may be an INSERT, UPDATE, or DELETE statement or an SQL statement that returns nothing, such as an SQL DDL statement. This method should be used when the returned row count may exceed Integer.MAX_VALUE.

Specified by:
  `executeLargeUpdate` in interface `Statement`
Parameters:
  `sql` - sql command
Returns:
  update counts
Throws:
  `SQLException` - if any error occur during execution

#### executeLargeUpdate

    public long executeLargeUpdate​(String sql,
                                   int autoGeneratedKeys)
                            throws SQLException

Identical to executeLargeUpdate(String sql), with a flag that indicate that autoGeneratedKeys (primary key fields with "auto_increment") generated id's must be retrieved.

Those id's will be available using getGeneratedKeys() method.

Specified by:
  `executeLargeUpdate` in interface `Statement`
Parameters:
  `sql` - sql command
  `autoGeneratedKeys` - a flag indicating whether auto-generated keys should be made available for retrieval; one of the following constants: Statement.RETURN_GENERATED_KEYS Statement.NO_GENERATED_KEYS
Returns:
  update counts
Throws:
  `SQLException` - if any error occur during execution

#### executeLargeUpdate

    public long executeLargeUpdate​(String sql,
                                   int[] columnIndexes)
                            throws SQLException

Identical to executeLargeUpdate(String sql, int autoGeneratedKeys) with autoGeneratedKeys = Statement.RETURN_GENERATED_KEYS set.

Specified by:
  `executeLargeUpdate` in interface `Statement`
Parameters:
  `sql` - sql command
  `columnIndexes` - column Indexes
Returns:
  update counts
Throws:
  `SQLException` - if any error occur during execution

#### executeLargeUpdate

    public long executeLargeUpdate​(String sql,
                                   String[] columnNames)
                            throws SQLException

Identical to executeLargeUpdate(String sql, int autoGeneratedKeys) with autoGeneratedKeys = Statement.RETURN_GENERATED_KEYS set.

Specified by:
  `executeLargeUpdate` in interface `Statement`
Parameters:
  `sql` - sql command
  `columnNames` - columns names
Returns:
  update counts
Throws:
  `SQLException` - if any error occur during execution

#### getLargeMaxRows

    public long getLargeMaxRows()
                         throws SQLException

Retrieves the maximum number of rows that a ResultSet object produced by this Statement object can contain. If this limit is exceeded, the excess rows are silently dropped.

Specified by:
  `getLargeMaxRows` in interface `Statement`
Returns:
  the current maximum number of rows for a ResultSet object produced by this Statement object; zero means there is no limit
Throws:
  `SQLException` - if this method is called on a closed Statement

#### setLargeMaxRows

    public void setLargeMaxRows​(long max)
                         throws SQLException

Sets the limit for the maximum number of rows that any ResultSet object generated by this Statement object can contain to the given number. If the limit is exceeded, the excess rows are silently dropped.

Specified by:
  `setLargeMaxRows` in interface `Statement`
Parameters:
  `max` - the new max rows limit; zero means there is no limit
Throws:
  `SQLException` - if the condition max >= 0 is not satisfied

#### getLargeUpdateCount

    public long getLargeUpdateCount()
                             throws SQLException

Retrieves the current result as an update count; if the result is a ResultSet object or there are no more results, -1 is returned.

Specified by:
  `getLargeUpdateCount` in interface `Statement`
Returns:
  last update count
Throws:
  `SQLException` - if this method is called on a closed Statement

#### executeLargeBatch

    public long[] executeLargeBatch()
                             throws SQLException

Execute batch, like executeBatch(), with returning results with long[]. For when row count may exceed Integer.MAX_VALUE.

Specified by:
  `executeLargeBatch` in interface `Statement`
Returns:
  an array of update counts (one element for each command in the batch)
Throws:
  `SQLException` - if a database error occur.

#### executeInternalBatchPipeline

    public List<Completion> executeInternalBatchPipeline()
                                                  throws SQLException

Throws:
  `SQLException`

#### executeInternalBatchStandard

    public List<Completion> executeInternalBatchStandard()
                                                  throws SQLException

Throws:
  `SQLException`